Bdraw_all:
    .ptr  equ dword[ebp-8]

     push  ebp
     mov   ebp,esp
     sub   esp,64



     mov   ecx,BXRES * BYRES
     cld
     mov   eax,0xff1f1f1f
     mov   edi,Bbuffer
     rep   stosd

     mov   [global_points_counter],0

     fninit
     push  dword BXRES
     fild  word[Bix1_axis]
     fiadd dword[esp-4]
     fstp  dword[Bx1_axis]
     fild  [Biy1_axis]
     fstp  [By1_axis]
     mov   dword[Bz1_axis],0.0

     fild  word[Bix2_axis]
     fiadd dword[esp-4]
     fstp  dword[Bx2_axis]
     fild  [Biy2_axis]
     fstp  [By2_axis]
     mov   dword[Bz2_axis],0.0
     pop   eax

     mov   eax,[Bix1_axis]   
     mov   cl,253
     pushad
     call  Bputpixel
     popad

     mov   eax,[Bix2_axis]
     mov   cl,254
     pushad
     call  Bputpixel
     popad

     pushad
     movzx  eax,word[Bix1_axis]
     movzx  ebx,word[Biy1_axis]
     movzx  ecx,word[Bix2_axis]
     movzx  edx,word[Biy2_axis]
     mov    [screen_width_var],BXRES
     mov    [lbuffer_ptr],Bbuffer
     call   linea
     popad

     mov   esi,Biderives	; draw derives -> lines
     mov   ecx,BSEGMENTS*2
  @@:
     pushad
     movzx  eax,word[esi]
     movzx  ebx,word[esi+2]
     movzx  ecx,word[esi+4]
     movzx  edx,word[esi+6]
     mov    [screen_width_var],BXRES
     call   linea
     popad
     add    esi,8
     loop   @b


     mov  esi,Biderives
     xor  ecx,ecx		    ; draw red sqares
   @@:				    ; derives start and end
     mov  eax,dword[esi]
     pushad
     call  Bputpixel
     popad
     add   esi,4
     inc   ecx
     cmp   ecx,BSEGMENTS*4 ;*3+1
     jnz   @b






     xor   edx,edx		    ; draw segments of bezier curves
     mov   esi,Biderives
     mov   .ptr,Bpoints
  .next_seg:
     push  edx
     xor   ebx,ebx
   @@:
     fninit
     fild  word[esi]
     fstp  [ebx+Bp1x]
     fild  word[esi+2]
     fstp  [ebx+Bp1y]
     mov   dword[ebx+Bp1z],0.0

     add   esi,4
     add   ebx,12
     cmp   ebx,48
     jnz   @b


     pushad
     mov      esi,.ptr
     call     draw_curve
   @@:

     popad
   ;000000000000  add	 .ptr,BSTEPS * 12
     pop    edx
     add    edx,1
     cmp    edx,BSEGMENTS
     jnz   .next_seg

     mov    esp,ebp
     pop    ebp
ret
Bputpixel:
  emms
  mov	  ebx,(BYRES-5)*65536+BXRES-5
  movd	  mm0,ebx
  mov	  ebx,5*65536+5
  movd	  mm1,ebx
  movd	  mm2,eax
  pmaxsw  mm2,mm1
  pminsw  mm2,mm0

  movd	 eax,mm2
  mov	 edx,BXRES
  movzx  ebx,ax
  shr	 eax,16
  mul	 edx
  add	 eax,ebx
  shl	 eax,2
  add	 eax,Bbuffer

  mov	  edi,eax	       ; draw line handle
  mov	  al,cl 	       ; cl -> crucial point number
  shl	  eax,24
  cmp	  cl,253
  jae	  .axis
  or	  eax,0x00ff0000
  jmp	  .draw
 .axis:
  or	  eax,0x0000ffff
 .draw:
  sub	  edi,2*BXRES*4+20
  mov	  ecx,5
  cld
  rep	  stosd
  add	  edi,BXRES*4-20
  mov	  ecx,5
  rep	  stosd
  add	  edi,BXRES*4-20
  mov	  ecx,5
  rep	  stosd
  add	  edi,BXRES*4-20
  mov	  ecx,5
  rep	  stosd
  add	  edi,BXRES*4-20
  mov	  ecx,5
  rep	  stosd

  emms
ret
Binit_derives:
   rdtsc
   mov	[rand_seed],ax
   mov	esi,Biderives
   mov	ecx,BSEGMENTS*4
 @@:
   push  ecx

   xor	 ecx,ecx
   mov	 edx,BXRES-1
   call  random
   mov	 word[esi],ax

   xor	 ecx,ecx
   mov	 edx,BYRES-1
   call  random
   mov	 word[esi+2],ax

   add	 esi,4
   pop	 ecx
   loop  @b
ret